//----------------------------------------------------------------------------------------------
//Board Library : Seeed nRF52 mbed-enable Borads 2.9.2
//Board Select  : Seeed nRF52 mbed-enable Borads / Seeed XIAO BLE - (nRF52840)
//----------------------------------------------------------------------------------------------
// 2023/11/12
//Arduino15\packages\Seeeduino\hardware\nrf52\1.1.4\variants\Seeed_XIAO_nRF52840_Sense\variant.cpp
//#define PIN_VBAT        P0_31  // battery voltage (predefined)
//#define PIN_VBAT_ENABLE P0_14  // LOW:read anable (predefined)
#define PIN_HICHG       P0_13  // charge current setting LOW:100mA HIGH:50mA
#define PIN_CHG         P0_17  // charge indicatore LOW:charge HIGH:discharge

void setup()
{
  Serial.begin(115200);
  while (!Serial);
 
  pinMode(PIN_VBAT_ENABLE, OUTPUT);
  pinMode(PIN_HICHG, OUTPUT);
  pinMode(PIN_CHG, INPUT);
  digitalWrite(PIN_VBAT_ENABLE, LOW); // VBAT read enable
  digitalWrite(PIN_HICHG, LOW);       // charge current 100mA

  analogReference(AR_INTERNAL2V4);    // default 2.4V
  analogAcquisitionTime(AT_40_US);    // default 10uS
  analogReadResolution(12);           // default 10bits
}

void loop()
{
  digitalWrite(LED_GREEN, LOW);
  digitalWrite(LED_BUILTIN, LOW);

  int vbatt = analogRead(PIN_VBAT);
  int vbatt1 = analogRead(P0_31);  
  Serial.print((2.961 * 2.4 * vbatt) / 4096);  // Resistance ratio 2.961, Vref = 2.4V　
  Serial.print("    ");
  Serial.print((2.961 * 2.4 * vbatt1) / 4096);  // Resistance ratio 2.961, Vref = 2.4V
  Serial.print("    ");
  Serial.println(digitalRead(PIN_CHG));        // 0:charge 1:discharge
  
  delay(500);
  digitalWrite(LED_GREEN, HIGH);
  digitalWrite(LED_BUILTIN, HIGH);
  delay(500);
}
